<?php
// ***** BEGIN LICENSE BLOCK *****
// Version: MPL 1.1/GPL 2.0/LGPL 2.1
//
// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is Mozilla Update.
//
// The Initial Developer of the Original Code is
// Chris "Wolf" Crews.
// Portions created by the Initial Developer are Copyright (C) 2004
// the Initial Developer. All Rights Reserved.
//
// Contributor(s):
//   Chris "Wolf" Crews <psychoticwolf@carolina.rr.com>
//   Alan Starr <alanjstarr@yahoo.com>
//
// Alternatively, the contents of this file may be used under the terms of
// either the GNU General Public License Version 2 or later (the "GPL"), or
// the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
// in which case the provisions of the GPL or the LGPL are applicable instead
// of those above. If you wish to allow use of your version of this file only
// under the terms of either the GPL or the LGPL, and not to allow others to
// use your version of this file under the terms of the MPL, indicate your
// decision by deleting the provisions above and replace them with the notice
// and other provisions required by the GPL or the LGPL. If you do not delete
// the provisions above, a recipient may use your version of this file under
// the terms of any one of the MPL, the GPL or the LGPL.
//
// ***** END LICENSE BLOCK *****
?>
<?php
require"../core/config.php";

$app = strtolower($_GET["application"]);  // Firefox, Thunderbird, Mozilla
$type = escape_string($_GET["type"]); //E, T, [P]
$list = ucwords(strtolower($_GET["list"])); // Newest, Updated, [Editors], Popular

$sitetitle =       "Mozilla Update";
$siteicon =        "http://www.mozilla.org/images/mozilla-16.png";
$siteurl =         $_SERVER["SERVER_NAME"];
$sitedescription = "the way to keep your mozilla software up-to-date";
$sitelanguage =    "en-US";
$sitecopyright =   "Copyright 2004-2005 The Mozilla Organization";
$currenttime =     gmdate(r);// GMT 
$rssttl =          "120"; //Life of feed in minutes

header("Content-Type: application/xml; charset=utf-8");

// Firefox, extensions, by date added

$select = "SELECT DISTINCT 
main.ID, 
main.Name AS Title, 
main.Description,  
version.Version, 
version.vID,
version.DateUpdated AS DateStamp,
applications.AppName";

$from = "FROM  main 
INNER  JOIN version ON main.ID = version.ID
INNER  JOIN applications ON version.AppID = applications.AppID";

$where = "`approved` = 'YES'"; // Always have a WHERE

if ($app == 'firefox' || $app == 'thunderbird' || $app == 'mozilla') {
  $where .= " AND applications.AppName = '$app'";
}

if ($type == 'E' || $type == 'T' || $type == 'P') {
  $where .= " AND main.Type = '$type'";
}

switch ($list) {
   case "Popular":
     $orderby = "main.DownloadCount DESC";
     break;
   case "Updated":
     $orderby = "main.DateUpdated DESC";
     break;
   case "Rated":
     $orderby = "main.Rating DESC";
     break;
   case "Newest":
   default:
     $orderby = "main.DateAdded DESC";
     break;
}

$sql = $select . " " . $from . " WHERE " . $where . " ORDER BY " . $orderby . " LIMIT 0, 10";

//echo $sql;

include"inc_rssfeed.php";


?>
